#include <GDIPlus.au3>

Global $hGUI, $hGFX, $hBMP, $hBUF, $hANI, $bExit = False

Opt('GUIOnEventMode', 1)

_GDIPlus_Startup()

$hGUI = GUICreate('Test', 300, 300)
$hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
$hBMP = _GDIPlus_BitmapCreateFromGraphics(300, 300, $hGFX)
$hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
$hANI = _GDIPlus_AnimationCreateFromFile('ani.png')

_GDIPlus_GraphicsSetInterpolationMode($hBUF, 5)
_GDIPlus_GraphicsSetPixelOffsetMode($hBUF, 2)

GUISetOnEvent(-3, '_Exit', $hGUI)
GUISetState()

While Sleep(10) And Not $bExit
	_GDIPlus_GraphicsClear($hBUF, 0xFF808080)
	_GDIPlus_GraphicsDrawAnimationRect($hBUF, $hANI, 0, 0, 50, 50)
	_GDIPlus_GraphicsDrawAnimationRect($hBUF, $hANI, 250, 250, 50, 50)
	_GDIPlus_GraphicsDrawAnimationRect($hBUF, $hANI, 0, 250, 50, 50)
	_GDIPlus_GraphicsDrawAnimationRect($hBUF, $hANI, 250, 0, 50, 50)
	_GDIPlus_GraphicsDrawAnimationRect($hBUF, $hANI, 50, 50, 200, 200)
	_GDIPlus_GraphicsDrawImage($hGFX, $hBMP, 0, 0)
WEnd

_GDIPlus_AnimationDispose($hANI)
_GDIPlus_GraphicsDispose($hBUF)
_GDIPlus_BitmapDispose($hBMP)
_GDIPlus_GraphicsDispose($hGFX)
_GDIPlus_Shutdown()

Func _Exit()
	$bExit = True
EndFunc

Func _GDIPlus_AnimationCreateFromFile($sPath)
	Local $aRET[7] ; 0 - ImageHandle, 1 - Breite, 2 - Hhe, 3 - Anzahl, 4 - Timer, 5 - Aktuelles Bild, 6 - TimeArray
	$aRET[0] = _GDIPlus_ImageLoadFromFile($sPath)
	If @error Then Return SetError(@error, 0, 0)
	$aRET[2] = _GDIPlus_ImageGetHeight($aRET[0]) - 1
	Local $iW = _GDIPlus_ImageGetWidth($aRET[0])
	For $i = 1 To $iW - 1 Step 1
		If Not _GDIPlus_BitmapGetPixel($aRET[0], $i, 0) = 0 Then ExitLoop
	Next
	$aRET[3] = Int(Round($iW / $i, 0))
	$aRET[1] = $i
	Local $aTIME[$aRET[3]]
	For $i = 0 To $aRET[3] - 1 Step 1
		$aTIME[$i] = BitAND(0xFFFFFF, _GDIPlus_BitmapGetPixel($aRET[0], $i * $aRET[2], 0))
	Next
	$aRET[4] = TimerInit()
	$aRET[5] = 0
	$aRET[6] = $aTIME
	Return $aRET
EndFunc

Func _GDIPlus_GraphicsDrawAnimationRect($hGFX, ByRef $hANI, $iX, $iY, $iW, $iH)
	Local $aTIME = $hANI[6]
	If TimerDiff($hANI[4]) > $aTIME[$hANI[5]] Then
		$hANI[4] = TimerInit()
		$hANI[5] += 1
		If $hANI[5] = $hANI[3] Then $hANI[5] = 0
	EndIf
;~ 	ToolTip(Int(TimerDiff($hANI[4])) & '/' & $aTIME[$hANI[5]]) ; Nur zur demonstration, daher spter unbedingt auskommentieren !
	_GDIPlus_GraphicsDrawImageRectRect($hGFX, $hANI[0], $hANI[1] * $hANI[5], 1, $hANI[1], $hANI[2], $iX, $iY, $iW, $iH)
EndFunc

Func _GDIPlus_AnimationDispose(ByRef $hANI)
	_GDIPlus_ImageDispose($hANI[0])
	$hANI = 0
EndFunc